package io.terminus.monitor.module;

/**
 * User : yh
 * Date : 17/2/20
 */

import android.content.Context;
import android.widget.Toast;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

import io.terminus.monitor.RNMobClickAgent;
import io.terminus.monitor.model.ErrorModel;
import io.terminus.monitor.util.ToolUtil;

/**
 * 异常捕获
 */
public class CrashHandler implements Thread.UncaughtExceptionHandler{
    private  static CrashHandler mHandler;
    private Context mContext;
    private Thread.UncaughtExceptionHandler mDefaultHandler;
    private DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");

    private CrashHandler(){

    }

    public static CrashHandler getInstance(){
        if(mHandler == null){
            mHandler = new CrashHandler();
        }
        return mHandler;
    }

    public void init(Context context){
        mContext = context;
        mDefaultHandler = Thread.getDefaultUncaughtExceptionHandler();
        Thread.setDefaultUncaughtExceptionHandler(this);

    }


    @Override
    public void uncaughtException(Thread thread, Throwable ex) {
        if(mDefaultHandler != null) {
            handleException(ex);
        }
        try{
            Thread.sleep(3000);
        }catch (Exception e){
            e.printStackTrace();
        }
        android.os.Process.killProcess(android.os.Process.myPid());
        System.exit(1);
    }

    private void handleException(Throwable ex){
        ErrorModel model = new ErrorModel();
//        model.setCreateTime(ToolUtil.getNowTime());
        model.setErm(ex.getMessage());
//        model.setDate(ToolUtil.getNowTime());
        model.setSta(getStrackTrace(ex.getStackTrace()));
        System.out.println(getStrackTrace(ex.getStackTrace()));
        RNMobClickAgent.getInstance().onEvent(model);
    }

    public static String getStrackTrace(StackTraceElement[] trace){
        if(trace == null || trace.length < 1){
            return "";
        }
        StringBuffer buf = new StringBuffer("");
        for(int count = 0; count < trace.length; ++count){
            buf.append(trace[count].toString());
            buf.append("\n");
        }
        return buf.toString();
    }
}
