package io.terminus.monitor.module;


import android.content.Context;

import org.litepal.LitePal;
import org.litepal.crud.DataSupport;

import java.util.ArrayList;
import java.util.List;

import io.terminus.monitor.model.BaseModel;

/**
 * User : yh
 * Date : 17/2/21
 */

public class LitePalHelper<T extends BaseModel> {

    private static LitePalHelper helper;
    private List<Class<T> > classList;

    private LitePalHelper(){
        classList = new ArrayList<>();
    }

    public void init(Context mContext){
        LitePal.initialize(mContext);
    }

    public void LogModelRegist(Class<T> t){
        if(classList.contains(t)){
            return;
        }
        classList.add(t);
    }

    public static LitePalHelper getInstance(){
        if(helper == null){
            helper = new LitePalHelper();
        }
        return helper;
    }

    public void save(T t){
        t.save();
    }

    public T getData(Class<T> t){
        return DataSupport.find(t,1);
    }

    public void deleteData(Class<T> t,long id){
        DataSupport.delete(t,id);
    }

    public List<T> getAllData(){
        List<T> all = new ArrayList<>();
        for(Class<T> cls : classList){
            all.addAll(DataSupport.findAll(cls));
        }
        return all;
    }

    public int count(){
        int count = 0;
        for(Class<T> cls : classList){
            count += DataSupport.count(cls);
        }
        return count;
    }

}
