package io.terminus.monitor.module;

import android.content.Context;
import android.view.Choreographer;

import com.facebook.react.bridge.ReactContext;
import com.facebook.react.bridge.UiThreadUtil;
import com.facebook.react.modules.debug.FpsDebugFrameCallback;

import io.terminus.monitor.model.PerformanceModel;
import io.terminus.monitor.util.ToolUtil;

/**
 * User : yh
 * Date : 17/2/22
 */

public class PerFormanceTool {
    private static PerFormanceTool tool;
    private double fps;
    private double jsfps;
    private double cpu;
    private double memory;

    private PerFormanceTool(){
    }

    public static PerFormanceTool getInstance(){
        if(tool == null){
            tool = new PerFormanceTool();
        }
        return tool;
    }

    public void init(final ReactContext mContext){
//        mFrameCallback = new FpsDebugFrameCallback(Choreographer.getInstance(), mContext);
//        mFrameCallback.start();
    }

    public void pageLoadTime(String pageName,String pageTime) {
        PerformanceModel model = new PerformanceModel();
        model.setNt(pageTime);
        model.setDp(pageName);
        UploadManager.getInstance().addTask(model);
    }

    public void setFPS(double fps,double jsfps){
        this.fps = fps;
        this.jsfps = jsfps;
        this.cpu = ToolUtil.getProcessCpuRate();
        this.memory = Runtime.getRuntime().totalMemory()/(1024*1024.0);
        PerformanceModel model = new PerformanceModel();
//        model.setFps(fps);
//        model.setCpu(cpu);
//        model.setMem( memory);
        UploadManager.getInstance().addTask(model);
    }
}
