package io.terminus.monitor.util;

import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.text.format.DateFormat;

import com.google.gson.Gson;
import com.loopj.android.http.RequestParams;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.Method;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;

import io.terminus.monitor.AnalyticsConfig;
import io.terminus.monitor.model.Enum.NetInfoEnum;
import java.util.Calendar;
import java.util.Date;
import java.util.Objects;

/**
 * User : yh
 * Date : 17/2/20
 */

public class ToolUtil {

    public static boolean isDebug(Context mContext){
        ApplicationInfo info = mContext.getApplicationInfo();
        if((info.flags & ApplicationInfo.FLAG_DEBUGGABLE) != 0){
            return true;
        }
        return false;
    }

    public static boolean isWifi(Context mContext){
        if(DeviceUtil.getNetWorkInfo(mContext) == NetInfoEnum.WIFI){
            return true;
        }
        return false;
    }

    public static boolean root(){
        try{
            if(!new File("/system/bin/su").exists() && !new File("/system/xbin/su").exists()){
                return false;
            }
            return true;
        }catch (Exception e){

        }
        return false;
    }

    /**
     *
     * @return yyyy-MM-dd HH:mm:ss
     */
    public static String getNowTime(){

        long time= System.currentTimeMillis();
        return  String.valueOf(time);
    }

    /**
     *
     * @return time
     */
    public static long getNowTimeMillis(){
        Date time = new Date(System.currentTimeMillis());
        return time.getTime();
    }


    public static float getProcessCpuRate()
    {

        float totalCpuTime1 = getTotalCpuTime();
        float processCpuTime1 = getAppCpuTime();
        try
        {
            Thread.sleep(360);

        }
        catch (Exception e)
        {
        }

        float totalCpuTime2 = getTotalCpuTime();
        float processCpuTime2 = getAppCpuTime();

        float cpuRate = 100 * (processCpuTime2 - processCpuTime1)
                / (totalCpuTime2 - totalCpuTime1);

        return cpuRate;
    }

    private static long getTotalCpuTime()
    { // 获取系统总CPU使用时间
        String[] cpuInfos = null;
        try
        {
            BufferedReader reader = new BufferedReader(new InputStreamReader(
                    new FileInputStream("/proc/stat")), 1000);
            String load = reader.readLine();
            reader.close();
            cpuInfos = load.split(" ");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
        long totalCpu = Long.parseLong(cpuInfos[2])
                + Long.parseLong(cpuInfos[3]) + Long.parseLong(cpuInfos[4])
                + Long.parseLong(cpuInfos[6]) + Long.parseLong(cpuInfos[5])
                + Long.parseLong(cpuInfos[7]) + Long.parseLong(cpuInfos[8]);
        return totalCpu;
    }

    private static long getAppCpuTime()
    { // 获取应用占用的CPU时间
        String[] cpuInfos = null;
        try
        {
            int pid = android.os.Process.myPid();
            BufferedReader reader = new BufferedReader(new InputStreamReader(
                    new FileInputStream("/proc/" + pid + "/stat")), 1000);
            String load = reader.readLine();
            reader.close();
            cpuInfos = load.split(" ");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
        long appCpuTime = Long.parseLong(cpuInfos[13])
                + Long.parseLong(cpuInfos[14]) + Long.parseLong(cpuInfos[15])
                + Long.parseLong(cpuInfos[16]);
        return appCpuTime;
    }

    public static RequestParams toRequestParams(Object obj){
        RequestParams params = new RequestParams();
        Method[] methods = obj.getClass().getMethods();
        try {
            for (Method m : methods) {
                if (m.getName().startsWith("get") && !m.getName().startsWith("getClass") && !m.getName().equals("getId")) {
                    if(m.invoke(obj) == null){continue;}
                    String value = String.valueOf((Object) m.invoke(obj));
                    value = URLEncoder.encode(value,"UTF-8");
                    if(value != null){
                        String name = m.getName().substring(3, 4).toLowerCase() + m.getName().substring(4);
                        params.put(name,value);
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return params;
    }

}
