//
//  RNMonitorConfig.m
//  RNMonitor
//
//  Created by zhiyu on 17/2/23.
//  Copyright © 2017年 Facebook. All rights reserved.
//

#import "RNMonitorConfig.h"
#import "RNPageManager.h"
#import "RNCusEventManager.h"
#import "RNDeviceManager.h"
#import "RNLogManager.h"
#import "RNPerformanceManager.h"
#import "RNRequestManager.h"
#import "RNDevice.h"
#import "Reachability.h"
#import "RNFMDB.h"
#import "RNMonitorUploadManager.h"
NSString *  KModelName = @"RNMonitor";
NSString *  KDeviceEntityName = @"device";
NSString *  KEventEntityName = @"event";
NSString *  KPageEntityName = @"document";
NSString *  KLogEntityName = @"error";
NSString *  KPerformanceEntityName = @"timing";
NSString *  KRequestEntityName = @"request";


@implementation RNMonitorConfig{
       Reachability *_reachability;
}
+ (instancetype)shareInstance {
    static RNMonitorConfig *_instance;
    static dispatch_once_t once_t;
    dispatch_once(&once_t, ^{
        if (!_instance) {
            _instance = [[self alloc] init];
        }
    });
    return _instance;
}

- (instancetype)init
{
    self = [super init];
    if (self) {
        _type = RNUploadTypeActivate;
        _baseURL = @"https://analytics.terminus.io/collect";
        _uploadLimit = 10;
        _Debug = YES;
//        [NSURLProtocol registerClass:[RNFlow class]];
    }
    return self;
}


- (void)startMonitorWithAppKey:(NSString *)appKey {
    _appKey = appKey;
    [self startMonitor];
    

    
    if (_type == RNUploadTypeActivate) {
        [self uploadAllLastMessage:NO];
    }else if (_type == RNUploadTypeWifiLimit){
        [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(netWorkStatusChange) name:kReachabilityChangedNotification object:nil];
        _reachability = [Reachability reachabilityForInternetConnection];
        [_reachability startNotifier];
        [self netWorkStatusChange];
    }
    
}


- (void)startMonitor{
    
    [RNFMDB shareDatabase:KModelName];
    [[RNDeviceManager shareInstance] start];
    [[RNLogManager shareInstance] start];
    [[RNPageManager shareInstance] start];
    [[RNPerformanceManager shareInstance] start];
    [[RNRequestManager shareInstance] start];
    

    //    [[RNCusEventManager shareInstance] start];

}

- (void)uploadAllLastMessage:(BOOL)Limit{
    [RNMonitorUploadManager uploadMonitor:KDeviceEntityName];
    [RNMonitorUploadManager uploadMonitor:KLogEntityName];
    [RNMonitorUploadManager uploadMonitor:KPerformanceEntityName];
    [RNMonitorUploadManager uploadMonitor:KRequestEntityName];
    [RNMonitorUploadManager uploadMonitor:KPageEntityName];
    

//    [RNMonitorUploadManager uploadMonitor:KEventEntityName];

}

- (void)netWorkStatusChange{
    if([_reachability currentReachabilityStatus] == ReachableViaWiFi){
        [self uploadAllLastMessage:YES];
    }
}
@end
