//
//  RNDeviceManager.m
//  RNMonitor
//
//  Created by zhiyu on 17/2/22.
//  Copyright © 2017年 Facebook. All rights reserved.
//

#import "RNDeviceManager.h"
#import "RNDevice.h"
#import "RNMonitorConfig.h"
#import "RNDataManager.h"
#import "RNUpdateService.h"
#import "RNUtil.h"
#import "RNDeviceDO.h"
#import "RNFMDB.h"
#import "RNMonitorUploadManager.h"
@interface RNDeviceManager ()


@end
@implementation RNDeviceManager

+ (instancetype)shareInstance {
    static RNDeviceManager *_instance;
    static dispatch_once_t once_t;
    dispatch_once(&once_t, ^{
        if (!_instance) {
            _instance = [[self alloc] init];
        }
    });
    return _instance;
}

- (instancetype)init
{
    self = [super init];
    if (self) {
        [[RNFMDB shareDatabase] jq_createTable:KDeviceEntityName
                                    dicOrModel:[RNDeviceDO new]];
    }
    return self;
}

- (void)start{
    RNDeviceDO *deviceDO = [RNDeviceDO new];
    deviceDO.sr = [RNDevice iphoneResolution];
    deviceDO.ch = @"appStore";
    deviceDO.jb = [NSString stringWithFormat:@"%d",[RNDevice iphoneIsJailbreak]];
    deviceDO.rom = [RNDevice diskOfAllSizeMBytes];
    deviceDO.mem = [RNDevice availableMemory];
    deviceDO.cpu = [RNDevice cpuType];
    deviceDO.sdk = [RNDevice minimumSystemVersion];
    
    
 

    if (_extra) {
        deviceDO.extra = _extra;
    }
    [RNMonitorUploadManager applyBaseParam:KDeviceEntityName
                                  pageName:nil
                                      data:deviceDO];
    
}

@end
