//
//  LPPageManager.m
//  demo
//
//  Created by zhiyu on 17/2/22.
//  Copyright © 2017年 terminus. All rights reserved.
//

#import "RNPageManager.h"
#import "RNMonitorConfig.h"
#import "RNDataManager.h"
#import "RNDevice.h"
#import "RNUtil.h"
#import "RNUpdateService.h"
#import "RNPageDO.h"
#import "NSObject+RNMIU_ToDictionary.h"
#import "RNFMDB.h"
#import "RNMonitorUploadManager.h"
NSString *  KReceivePageNotification = @"KReceiveDeviceNotification";
@implementation RNPageManager{
    NSMutableArray *_currentPageNames;
    NSString *_currentPageName;
    NSMutableDictionary *_currentData;
}

+ (instancetype)shareInstance {
    static RNPageManager *_instance;
    static dispatch_once_t once_t;
    dispatch_once(&once_t, ^{
        if (!_instance) {
            _instance = [[self alloc] init];
        }
    });
    return _instance;
}

- (void)start{
    [[RNFMDB shareDatabase] jq_createTable:KPageEntityName dicOrModel:[RNPageDO new]];
    _currentData = [NSMutableDictionary dictionary];
    
}

- (void)startPageView:(NSString *)pageName lastPage:(NSString*)lastPage
{
    _currentPageName = pageName;
    [_currentPageNames addObject:pageName];

    RNPageDO *pageDO = [RNPageDO new];
    pageDO.dr = lastPage;
    pageDO.startTime =  [NSString stringWithFormat:@"%f",CACurrentMediaTime()];
    pageDO.dt = pageName;
    if (_extra) {
        pageDO.extra = _extra;
    }
    [_currentData setObject:pageDO forKey:pageName];
    
}

- (void)endPageView:(NSString *)pageName {
    
    if ([_currentData.allKeys containsObject:pageName]) {
        RNPageDO *pageDO = _currentData[pageName];
        double time =(CACurrentMediaTime() - pageDO.startTime.doubleValue);
        pageDO.tp = [NSString stringWithFormat:@"%.0f",time];
        
        [RNMonitorUploadManager applyBaseParam:KPageEntityName
                                      pageName:pageName
                                          data:pageDO];
        
        [_currentData removeObjectForKey:pageName];
        _currentPageName = nil;
    }
}








@end
