//
//  RNFPS.m
//  RNMonitor
//
//  Created by zhiyu on 17/3/7.
//  Copyright © 2017年 Facebook. All rights reserved.
//

#import "RNFPS.h"

@implementation RNFPS{
    CADisplayLink *_link;
    NSUInteger _count;
    NSTimeInterval _lastTime;
}
+ (instancetype)shareInstance {
    static RNFPS *_instance;
    static dispatch_once_t once_t;
    dispatch_once(&once_t, ^{
        if (!_instance) {
            _instance = [[self alloc] init];
        }
    });
    return _instance;
}


- (void)startFPS {
    
    _link = [CADisplayLink displayLinkWithTarget:self selector:@selector(tick:)];
    [_link addToRunLoop:[NSRunLoop mainRunLoop] forMode:NSRunLoopCommonModes];
    _FPSs = [NSMutableArray array];
    
}

- (void)tick:(CADisplayLink *)link {
    if (_lastTime == 0) {
        _lastTime = link.timestamp;
        return;
    }
    
    _count++;
    NSTimeInterval delta = link.timestamp - _lastTime;
    if (delta < 1) return;
    _lastTime = link.timestamp;
    float fps = _count / delta;
    _count = 0;
    NSLog(@"%f",fps);
    [_FPSs addObject:[NSNumber numberWithFloat:fps]];
}

- (void)stopFPS{
    [_link invalidate];
    _link= nil;
}

- (void)dealloc {
    [_link invalidate];
    _link= nil;
}

@end
