//
//  RNFlow.m
//  RNMonitor
//
//  Created by zhiyu on 17/3/9.
//  Copyright © 2017年 Facebook. All rights reserved.
//

#import "RNNetworkFlowProtocol.h"
#import "RNPerformanceManager.h"
static NSString * const kLPNetworkProtocolHeaderKey = @"networkProtocol";
@interface RNNetworkFlowProtocol ()<NSURLConnectionDataDelegate>
@property(nonatomic,weak)NSURLConnection *connection;

@end
@implementation RNNetworkFlowProtocol
+ (BOOL)canInitWithRequest:(NSURLRequest *)request {
    if ([NSURLProtocol propertyForKey:kLPNetworkProtocolHeaderKey inRequest:request] ) {
        return NO;
    }
    if([@[@"http",@"https"] containsObject:request.URL.scheme]){
        return YES;
    }
    return NO;
}
+ (NSURLRequest *)canonicalRequestForRequest:(NSURLRequest *)request {
    return request;
}

+ (BOOL)requestIsCacheEquivalent:(NSURLRequest *)a toRequest:(NSURLRequest *)b {
    return [super requestIsCacheEquivalent:a toRequest:b];
}

- (void)startLoading {
    NSMutableURLRequest *newRequest = [self.request mutableCopy];
    newRequest.allHTTPHeaderFields = self.request.allHTTPHeaderFields;
    [NSURLProtocol setProperty:@YES forKey:kLPNetworkProtocolHeaderKey inRequest:self.request];
    self.connection = [NSURLConnection connectionWithRequest:self.request delegate:self];
    [self.connection start];
}

- (void)stopLoading {
    [self.client URLProtocolDidFinishLoading:self];
}

#pragma mark - <NSURLConnectionDataDelegate>


- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    
    if(connection.originalRequest){
//        [[RNPerformanceManager shareInstance] updateNetworkFlow:connection.originalRequest.HTTPBody.length];
        
    }
    [self.client URLProtocolDidFinishLoading:self];
    
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    [self.client URLProtocol:self didReceiveResponse:response cacheStoragePolicy:NSURLCacheStorageAllowed];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    
    [self.client URLProtocol:self didLoadData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    [self.client URLProtocol:self didFailWithError:error];
}
@end
