//
//  RNUpdateService.m
//  RNMonitor
//
//  Created by zhiyu on 17/2/27.
//  Copyright © 2017年 Facebook. All rights reserved.
//

#import "RNUpdateService.h"
#import "RNJSON.h"
#import "RNUtil.h"

@implementation RNUpdateService
+ (void)POST:(NSString *)URLString
  parameters:(id)params
 resultBlock:(RNHttpResultBlock)resultBlock {
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:URLString]];
    [request setHTTPMethod:@"POST"];
    [request setTimeoutInterval:20];
    [request setValue:@"IOS" forHTTPHeaderField:@"User-Agent"];
    [request setHTTPBody:[[self appendParams:params] dataUsingEncoding:NSUTF8StringEncoding]];
    [[[NSURLSession sharedSession] dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            if (error) {
                resultBlock(NO,nil,error);
                return ;
            }
            NSError *error;
            id dict = LPJSONDecode(data, &error);
            if ([dict isKindOfClass:[NSDictionary class]]) {
                if (dict[@"error"]) {
                    dispatch_async(dispatch_get_main_queue(), ^{
                        resultBlock(NO, nil, dict[@"error"]);
                    });
                    return;
                }
                dispatch_async(dispatch_get_main_queue(), ^{
                    resultBlock(YES, dict, nil);
                });
                
                return;
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                resultBlock(YES, nil, nil);
            });
            
            
        });
        
    }] resume];
    
}

+ (NSString*)appendParams:(id)parama{
    NSString *resultString = @"";
    if ([parama isKindOfClass:[NSDictionary class]]) {
        for (NSString *key in parama) {
            NSString *simpleString = @"";
            if ([parama[key] isKindOfClass:[NSArray class]]) {
                simpleString = [self appendParamsWithArray:parama[key]];
                resultString = [NSString stringWithFormat:@"%@%@%@",resultString,resultString.length>0?@"&":@"",simpleString];
            }else if ([parama[key] isKindOfClass:[NSDictionary class]]){
                simpleString = [self appendParamsWithDict:parama[key]];
                resultString = [NSString stringWithFormat:@"%@%@%@=%@",resultString,resultString.length>0?@"&":@"",key,simpleString];

            }else if([parama[key] isKindOfClass:[NSString class]]){
                simpleString = parama[key];
                resultString = [NSString stringWithFormat:@"%@%@%@=%@",resultString,resultString.length>0?@"&":@"",key,simpleString];

            }
        }
        
    }
    return resultString ;
}

+ (NSString*)appendParamsWithDict:(NSDictionary*)dict{
    NSString *resultString = @"";
    for (NSString*key in dict.allKeys) {
        resultString = [NSString stringWithFormat:@"%@%@%@=%@",resultString,resultString.length>0?@"&":@"",key,dict[key]];
    }
    return resultString;
    
}

+ (NSString*)appendParamsWithArray:(NSArray*)array {
    NSMutableArray *dataArray = [NSMutableArray array];
    NSString *result = @"";
    for (NSDictionary*dict in array) {
        NSString * dataString= @"";
        for (NSString*key in dict.allKeys) {
            if([dict[key] isKindOfClass:[NSString class]]){
            dataString =  [NSString stringWithFormat:@"%@%@%@=%@",dataString,dataString.length>0?@"&":@"",key,[self decodeString:dict[key]]];
            }
        }
        result = [NSString stringWithFormat:@"%@%@data=%@",result,result.length>0?@"&":@"",[self decodeString:dataString]];
    }

    
    return result;
}

+ (NSString*)decodeString:(NSString*)string{
  return   CFBridgingRelease(CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault,
                                                              (CFStringRef)string,
                                                              NULL,
                                                              (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                                              kCFStringEncodingUTF8));
}
@end
