//
//  LPLocation.m
//  RNMonitor
//
//  Created by zhiyu on 17/2/22.
//  Copyright © 2017年 Facebook. All rights reserved.
//

#import "RNLocationManager.h"

@interface RNLocationManager ()<CLLocationManagerDelegate>
@property (nonatomic, strong) CLLocationManager* locationManager;
@end
@implementation RNLocationManager{
    RNLocatingCompletionBlock _copyresultBlock;
    BOOL _hasLoction;
}

+ (instancetype)shareInstance {
    static RNLocationManager *_instance;
    static dispatch_once_t once_t;
    dispatch_once(&once_t, ^{
        if (!_instance) {
            _instance = [[self alloc] init];
            
        }
    });
    return _instance;
}
- (instancetype)init
{
    self = [super init];
    if (self) {
        self.locationManager = [[CLLocationManager alloc] init];
        self.locationManager.desiredAccuracy = kCLLocationAccuracyBest;
        self.locationManager.distanceFilter = 1000.f;
        self.locationManager.pausesLocationUpdatesAutomatically=YES;
        self.locationManager.delegate = self;

    }
    return self;
}
- (void)startLocation:(RNLocatingCompletionBlock)resultBlock
{
    _copyresultBlock = [resultBlock copy];
    if ([UIDevice currentDevice].systemVersion.floatValue >=8.0) {
        [_locationManager requestAlwaysAuthorization];
        [_locationManager requestWhenInUseAuthorization];
    }
     [self.locationManager startUpdatingLocation];
}


- (void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray<CLLocation *> *)locations
{
    CLLocation *location = [locations lastObject];
    CLLocationCoordinate2D coordinate = location.coordinate;
     _location = [NSString stringWithFormat:@"%f,%f",coordinate.longitude,coordinate.latitude];
    
    [self.locationManager stopUpdatingHeading];
}

- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error
{
    _copyresultBlock(nil,error);
}

@end
