//
// Created by Allen Chiang on 16/2/18.
// Copyright (c) 2016 terminus. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <objc/runtime.h>

typedef enum {
    RNMIU_CHAR, RNMIU_UNSIGNED_CHAR, RNMIU_SHORT, RNMIU_UNSIGNED_SHORT, RNMIU_INT, RNMIU_UNSIGNED, RNMIU_LONG, RNMIU_UNSIGNED_LONG,
    RNMIU_LONG_LONG, RNMIU_UNSIGNED_LONG_LONG, RNMIU_DOUBLE, RNMIU_FLOAT, RNMIU_C_BOOL,
    RNMIU_ID, RNMIU_STRUCT, RNMIU_FUNC, RNMIU_BLOCK, RNMIU_INT_P, RNMIU_VOID_P, RNMIU_CHAR_P, RNMIU_NIL
} RNMIU_TypeOfProperty;

@protocol RNMIUTransient
@end

@interface RNMPropertyAttributeInfo : NSObject
@property BOOL transient;
@property BOOL readOnly;
@property RNMIU_TypeOfProperty type;
@property Class clazz;
@property Class arrayClass;
@property(nonatomic, copy) NSString *dicPropertyName;
@property(nonatomic, copy) NSString *oriPropertyName;

@property SEL getter;
@property SEL setter;

@property(nonatomic, strong) NSArray *protocols;


+ (RNMPropertyAttributeInfo *)analyseProperty:(objc_property_t)pProperty
                                 WithClass:(Class)aClass
                       AndWithCurrentClass:(Class)currentClass;

+ (void)enumerateClassProperties:(Class)aClass
                   withInfoBlock:(void (^)(Class oriClass, Class currentClass, RNMPropertyAttributeInfo *info))infoBlock;

+ (id)getValue:(id)obj with:(RNMPropertyAttributeInfo *)info;

+ (NSArray *)getProtocolsFromClass:(Class)clazz;

@end


@interface RNMPropertyAttributeInfoCache : NSObject

+ (RNMPropertyAttributeInfoCache *)instance;

- (RNMPropertyAttributeInfo *)getFromCacheWithClass:(Class)clazz AndPropertyName:(NSString *)name;

- (void)putToCacheWithClass:(Class)clazz AndPropertyName:(NSString *)name WithInfo:(RNMPropertyAttributeInfo *)info;

@end

@interface RNMIUConvertDefine :NSObject

@end
