package io.terminus.monitor.util;

/**
 * Created by ZYWu on 2017/6/22.
 */

//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

import android.content.Context;
import android.content.SharedPreferences;
import android.provider.Settings;
import android.telephony.TelephonyManager;

import java.io.UnsupportedEncodingException;
import java.util.UUID;


public class DeviceIDUtil {
    protected static final String PREFS_FILE = "device_id.xml";
    protected static final String PREFS_DEVICE_ID = "device_id";
    protected static volatile UUID uuid;


    public DeviceIDUtil(Context context) {
        this.createUUID(context);
    }

    private void createUUID(Context context) {
        if(uuid == null) {
            Class var2 = DeviceIDUtil.class;
            synchronized(DeviceIDUtil.class) {
                if(uuid == null) {
                    SharedPreferences prefs = context.getSharedPreferences("device_id.xml", 0);
                    String id = prefs.getString("device_id", (String)null);
                    if(id != null) {
                        uuid = UUID.fromString(id);
                    } else {
                        String androidId = Settings.Secure.getString(context.getContentResolver(), "android_id");

                        try {
                            if(!"9774d56d682e549c".equals(androidId)) {
                                uuid = UUID.nameUUIDFromBytes(androidId.getBytes("utf8"));
                            } else {
                                String e = ((TelephonyManager)context.getSystemService("phone")).getDeviceId();
                                uuid = e != null?UUID.nameUUIDFromBytes(e.getBytes("utf8")):UUID.randomUUID();
                            }
                        } catch (UnsupportedEncodingException var8) {
                            throw new RuntimeException(var8);
                        }

                        prefs.edit().putString("device_id", uuid.toString()).commit();
                    }
                }
            }
        }

    }

    public  UUID getDeviceUUId() {
        return uuid;
    }

    public  String getDeviceId() {
        return this.getDeviceUUId().toString();
    }
}
